Wt: Wt::WTextEdit Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WTextEdit Class Reference

A rich-text XHTML editor. More...

`#include <Wt/WTextEdit.h>`

Inheritance diagram for Wt::WTextEdit:
[legend]

## Public Member Functions
| WTextEdit ()
| Creates a new text editor.
| WTextEdit (const WString &text)
| Creates a new text editor and initialize with given text.
| ~WTextEdit ()
| Destructor.
int | version () const
| Returns the TinyMCE version.
virtual void | setText (const WString &text) override
| Sets the content.
void | setStyleSheet (const std::string &uri)
| Sets the stylesheet for displaying the content.
const std::string | styleSheet () const
| Returns the content stylesheet.
void | setExtraPlugins (const std::string &plugins)
| Loads additional TinyMCE plugins.
const std::string | extraPlugins () const
| Returns the extra plugins.
void | setToolBar (int i, const std::string &config)
| Configures a tool bar.
const std::string | toolBar (int i) const
| Returns a tool bar configuration.
void | setConfigurationSetting (const std::string &name, const cpp17::any &value)
| Configure a TinyMCE setting.
cpp17::any | configurationSetting (const std::string &name) const
| Returns a TinyMCE configuration setting's value.
virtual void | setPlaceholderText (const WString &placeholder) override
| Sets the placeholder text.
virtual void | setReadOnly (bool readOnly) override
| Sets the element read-only.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
JSignal & | rendered ()
| Signal emitted when rendered.
Public Member Functions inherited from Wt::WTextArea
| WTextArea ()
| Creates a text area with empty content and optional parent.
| WTextArea (const WString &content)
| Creates a text area with given content and optional parent.
void | setColumns (int cols)
| Sets the number of columns.
void | setRows (int rows)
| Sets the number of rows.
int | columns () const
| Returns the number of columns.
int | rows () const
| Returns the number of rows.
const WString & | text () const
| Returns the current content.
int | selectionStart () const
| Returns the current selection start.
WString | selectedText () const
| Returns the currently selected text.
bool | hasSelectedText () const
| Returns whether there is selected text.
int | cursorPosition () const
| Returns the current cursor position.
virtual WString | valueText () const override
| Returns the current value.
virtual void | setValueText (const WString &text) override
| Sets the current value.
EventSignal & | textInput ()
| Event signal emitted when the text in the input field changed.
Public Member Functions inherited from Wt::WFormWidget
| WFormWidget ()
| Creates a WFormWidget.
| ~WFormWidget ()
| Destructor.
WLabel * | label () const
| Returns the label associated with this widget.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Sets the hidden state of this widget.
void | setValidator (const std::shared_ptr< WValidator > &validator)
| Sets a validator for this field.
virtual std::shared_ptr< WValidator > | validator () const
| Returns the validator.
virtual ValidationState | validate ()
| Validates the field.
void | setEnabled (bool enabled)
| Sets whether the widget is enabled.
bool | isReadOnly () const
| Returns whether the form element is read-only.
const WString & | placeholderText () const
| Returns the placeholder text.
EventSignal & | changed ()
| Signal emitted when the value was changed.
Signal< WValidator::Result > & | validated ()
| Signal emitted when the widget is being validated.
virtual void | refresh () override
| Refresh the widget.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual int | tabIndex () const override
| Returns the tab index.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget)
| Removes a child widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WTextArea
Protected Member Functions inherited from Wt::WFormWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WInteractWidget
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WFormWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WFormWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A rich-text XHTML editor.

The editor provides interactive editing of XHTML text. By default it provides basic mark-up (font, formatting, color, links, and lists), but additional buttons may be added to the tool bars that add additional formatting options.

The implementation is based on TinyMCE. The widget may be configured and tailored using the setConfigurationSetting() and related methods that provide direct access to the underlying TinyMCE component.

You can use this widget with TinyMCE version 3 or 4, but this requires different configurations.

By default, Wt assumes a 3.x version of TinyMCE. You need to download TinyMCE (version 3.5b1 or later) and deploy the `tinymce/jscripts/tiny_mce` folder to tinyMCEBaseURL. The default value for tinyMCEBaseURL is resourcesURL`/tiny_mce`, where resourcesURL is the configuration property that locates the Wt `resources/` folder (i.e., we assume by default that you copy the `tiny_mce` folder to the `resources/` folder), see also deployment and resources.

If you prefer to use TinyMCE 4 (or later) instead, you'll need to set the tinyMCEVersion property to 4 (or later). Note that TinyMCE changed its folder layout in version 4. You will need to deploy the `js/tinymce` folder to tinyMCEBaseURL. The default value for tinyMCEBaseURL for TinyMCE 4 (or later) is is resourcesURL`/tinymce` (i.e., we assume by default that you copy the `tiny_mce` folder to the `resources/` folder).

If the name of the main TinyMCE JavaScript file is not tinymce.js (e.g., you are using the minified version from the release package, or the CDN `//tinymce.cachefly.net/4.0/tinymce.min.js` or `//cdnjs.cloudflare.com/ajax/libs/tinymce/3.5.8/tiny_mce.js`), the URL to the main script file should be specified via tinyMCEURL.

Because the default folder names are different ("tiny_mce" for version 3 versus "tinymce" for version 4, you can have the resources for TinyMCE3 and TinyMCE4 alongside each other while experimenting with the old and new TinyMCE).

The default location for the TinyMCE resources may be overridden by configuring the tinyMCEBaseURL property in your Wt configuration file, see configuration properties.

Usage example:

auto w = std::make_unique<Wt::WContainerWidget>();
Wt::WLabel *label = w->addWidget(std::make_unique<Wt::WLabel>("Comments:"));
Wt::WTextEdit *edit = w->addWidget(std::make_unique<Wt::WTextEdit>(""));
label->setBuddy(edit);
Wt::WFormWidget::label
WLabel * label() const
Returns the label associated with this widget.
Definition WFormWidget.h:52
Wt::WLabel
A label for a form field.
Definition WLabel.h:57
Wt::WLabel::setBuddy
void setBuddy(WFormWidget *buddy)
Sets the buddy of this label.
Wt::WTextEdit
A rich-text XHTML editor.
Definition WTextEdit.h:94

### CSS

Styling through CSS is not applicable.

Default configuration of a WTextEdit

## Constructor & Destructor Documentation

## ◆ WTextEdit()

Wt::WTextEdit::WTextEdit | ( | const WString & | text | ) |

Creates a new text editor and initialize with given text.

The `text` should be valid XHTML.

## Member Function Documentation

## ◆ boxBorder()

virtual int Wt::WTextEdit::boxBorder | ( | Orientation | orientation | ) | const
| overrideprotectedvirtual

Returns the widget's built-in border width.

This is used by the layout managers to correct for a built-in border which interferes with setting a widget's width (or height) to 100%.

A layout manager needs to set the width to 100% only for form widgets (WTextArea, WLineEdit, WComboBox, etc...). Therefore, only for those widgets this needs to return the border width (the default implementation returns 0).

For form widgets, the border width depends on the specific browser/platform combination, unless an explicit border is set for the widget.

When setting an explicit border for the widget using a style class, you will want to reimplement this method to return this border width, in case you want to set the widget inside a layout manager.

See also
  boxPadding()

Reimplemented from Wt::WTextArea.

## ◆ boxPadding()

virtual int Wt::WTextEdit::boxPadding | ( | Orientation | orientation | ) | const
| overrideprotectedvirtual

Returns the widget's built-in padding.

This is used by the layout managers to correct for a built-in padding which interferes with setting a widget's width (or height) to 100%.

A layout manager needs to set the width to 100% only for form widgets (WTextArea, WLineEdit, WComboBox, etc...). Therefore, only for those widgets this needs to return the padding (the default implementation returns 0).

For form widgets, the padding depends on the specific browser/platform combination, unless an explicit padding is set for the widget.

When setting an explicit padding for the widget using a style class, you will want to reimplement this method to return this padding in case you want to set the widget inside a layout manager.

See also
  boxBorder()

Reimplemented from Wt::WTextArea.

## ◆ configurationSetting()

cpp17::any Wt::WTextEdit::configurationSetting | ( | const std::string & | name | ) | const

Returns a TinyMCE configuration setting's value.

An empty Any is returned when no value could be found for the provided argument.

## ◆ extraPlugins()

const std::string Wt::WTextEdit::extraPlugins | ( |  | ) | const

Returns the extra plugins.

See also
  setExtraPlugins()

## ◆ propagateSetEnabled()

virtual void Wt::WTextEdit::propagateSetEnabled | ( | bool | enabled | ) |
| overridevirtual

Propagates that a widget was enabled or disabled through children.

When enabling or disabling a widget, you usually also want to disable contained children. This method is called by setDisabled() to propagate its state to all children.

You may want to reimplement this method if they wish to render differently when a widget is disabled. The default implementation will propagate the signal to all children.

Reimplemented from Wt::WFormWidget.

## ◆ rendered()

JSignal & Wt::WTextEdit::rendered | ( |  | ) |

Signal emitted when rendered.

A text edit is instantiated asynchronously as it depends on additional JavaScript libraries and initialization. This signal is emitted when the component is initialized. The underlying TinyMCE editor component is accessible as jsRef() + ".ed".

## ◆ resize()

virtual void Wt::WTextEdit::resize | ( | const WLength & | width,
|  | const WLength & | height )
| overridevirtual

Resizes the widget.

Specifies a fixed size for this widget, setting CSS `width` and `height` properties. By default a widget has automatic width and height, which sets a size for the widget following CSS rules.

When the widget is not managed by a layout manager, the automatic (natural) size of a widget depends on whether they widget is a block or inline widget:

- a block widget takes by default the width of the parent, and the height that it needs based on its contents
- an inline widget takes the width and height that it needs based on its contents (possibly wrapping over multiple lines). The width and height of an inline widget cannot be changed (by the letter of CSS, although most browsers will react to it in varying ways).

When inserted in a layout manager, the size set will be used as a widget's preferred size, but the widget may be given a different size by the layout manager based on available space and stretch factors. The actual size given by a layout manager may be retrieved by making the widget "layout size aware", using setLayoutSizeAware(). If you have defined a `"wtResize()"` JavaScript method for the widget, then this method will also be called.

The default width and height of a widget is WLength::Auto.

See also
  width(), height()

Reimplemented from Wt::WWebWidget.

## ◆ setConfigurationSetting()

void Wt::WTextEdit::setConfigurationSetting | ( | const std::string & | name,
|  | const cpp17::any & | value )

Configure a TinyMCE setting.

A list of possible settings can be found at: http://tinymce.moxiecode.com/wiki.php/Configuration

The widget itself will also define a number of configuration settings and these may be overridden using this method.

## ◆ setExtraPlugins()

void Wt::WTextEdit::setExtraPlugins | ( | const std::string & | plugins | ) |

Loads additional TinyMCE plugins.

Wt loads by default only the plugin 'safari' (which adds support for the Safari web browser). Use this method to load additional plugins. Multiple plugins may be specified as a comma separated list.

The various plugins are described in the TinyMCE documentation.

Note
  Plugins can only be loaded before the initial display of the widget.

## ◆ setPlaceholderText()

virtual void Wt::WTextEdit::setPlaceholderText | ( | const WString & | placeholder | ) |
| overridevirtual

Sets the placeholder text.

This method is not supported on WTextEdit and will thrown an exception instead.

Reimplemented from Wt::WFormWidget.

## ◆ setReadOnly()

virtual void Wt::WTextEdit::setReadOnly | ( | bool | readOnly | ) |
| overridevirtual

Sets the element read-only.

A read-only form element cannot be edited, but the contents can still be selected.

By default, a form element area is not read-only.

See also
  setEnabled()

Reimplemented from Wt::WFormWidget.

## ◆ setStyleSheet()

void Wt::WTextEdit::setStyleSheet | ( | const std::string & | uri | ) |

Sets the stylesheet for displaying the content.

The content is rendered using the rules defined in this stylesheet. The stylesheet is also used to derive additional styles that are available in the text editor, for example in the "styleselect" button.

Multiple stylesheets may be specified as a comma separated list.

## ◆ setText()

virtual void Wt::WTextEdit::setText | ( | const WString & | text | ) |
| overridevirtual

Sets the content.

The `text` should be valid XHTML.

The default value is "".

Reimplemented from Wt::WTextArea.

## ◆ setToolBar()

void Wt::WTextEdit::setToolBar | ( | int | i,
|  | const std::string & | config )

Configures a tool bar.

This configures the buttons for the `i'th` tool bar (with 0 <= `i` <= 3).

### TinyMCE 3

The syntax and available buttons is documented in the TinyMCE documentation.

The default config for the first tool bar (`i` = 0) is: "fontselect, |, bold, italic, underline, |, fontsizeselect, |, forecolor, backcolor, |, justifyleft, justifycenter, justifyright, justifyfull, |, anchor, |, numlist, bullist".

By default, the other three tool bars are disabled (`config` = "").

### TinyMCE 4

The syntax and available buttons is documented in the TinyMCEdocumentation.

The default config for the first tool bar (`i` = 0) is: "undo redo | styleselect | bold italic | link".

Some buttons are only available after loading extra plugins using setExtraPlugins().

Note
  The tool bar configuration can only be set before the initial display of the widget.

## ◆ styleSheet()

const std::string Wt::WTextEdit::styleSheet | ( |  | ) | const

Returns the content stylesheet.

See also
  setStyleSheet()

## ◆ toolBar()

const std::string Wt::WTextEdit::toolBar | ( | int | i | ) | const

Returns a tool bar configuration.

See also
  setToolBar()

## ◆ version()

int Wt::WTextEdit::version | ( |  | ) | const

Returns the TinyMCE version.

This returns the configured version of TinyMCE (currently 3 or 4).